/* Problem URL: https://codeforces.com/contest/915/problem/D */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    V<V<pair<int, int>>> graph(n);

    rep(i, m) {
        int a, b;
        cin >> a >> b;

        graph[a - 1].emplace_back(b - 1, i);
    }

    V<bool> vis(n);
    V<bool> frame(n);

    vi choices;

    function<bool(int)> dfs = [&](int i) {
        vis[i] = true;
        frame[i] = true;

        for (auto [j, id] : graph[i]) {
            if (frame[j]) {
                choices.push_back(id);
                return true;
            }

            if (vis[j]) {
                continue;
            }

            if (dfs(j)) {
                choices.push_back(id);
                return true;
            }
        }

        frame[i] = false;

        return false;
    };

    rep(i, n) {
        if (vis[i]) {
            continue;
        }

        if (dfs(i)) {
            break;
        }
    }

    if (choices.empty()) {
        cout << "YES\n";
        return 0;
    }

    function<bool(int, int)> cyclecheck = [&](int i, int ig) {
        vis[i] = true;
        frame[i] = true;

        for (auto [j, id] : graph[i]) {
            if (id == ig) {
                continue;
            }

            if (frame[j]) {
                return true;
            }

            if (vis[j]) {
                continue;
            }

            if (cyclecheck(j, ig)) {
                return true;
            }
        }

        frame[i] = false;

        return false;
    };

    repv(ig, choices) {
        fill(all(vis), false);
        fill(all(frame), false);

        bool valid = true;

        rep(i, n) {
            if (vis[i]) {
                continue;
            }

            if (cyclecheck(i, ig)) {
                valid = false;
                break;
            }
        }

        if (valid) {
            cout << "YES\n";
            return 0;
        }
    }

    cout << "NO\n";
}
